import { Button, Form, FormInstance, Input, Select, Table } from "antd";
import { useCallback, useMemo, useRef, useState } from "react";
import { debounce } from "lodash";
import { DageTableActions } from "@dage/pc-components";
import { useNavigate } from "react-router-dom";

const DEFAULT_PARAMS = {
  pageNum: 1,
  pageSize: 20,
};

export default function MessagePage() {
  const navigate = useNavigate();
  const formRef = useRef<FormInstance>(null);
  const [loading, setLoading] = useState(false);
  const [list, setList] = useState<[]>([]);
  const [params, setParams] = useState({
    ...DEFAULT_PARAMS,
  });
  const [total, setTotal] = useState(0);

  const COLUMNS = useMemo(() => {
    return [
      {
        title: "留言时间",
        dataIndex: "title",
      },
      {
        title: "称号",
        dataIndex: "nickName",
      },
      {
        title: "联系方式",
        dataIndex: "date",
      },
      {
        title: "正文",
        dataIndex: "date",
      },
      {
        title: "操作",
        render: (item: any) => {
          return <DageTableActions onDelete={() => {}} />;
        },
      },
    ];
  }, []);

  const handleReset = useCallback(() => {
    formRef.current?.resetFields();
  }, [formRef]);

  const debounceSearch = useMemo(
    () => debounce((changedVal: unknown, vals: any) => {}, 500),
    []
  );

  const paginationChange = useCallback(
    () => (pageNum: number, pageSize: number) => {
      setParams({ ...params, pageNum, pageSize });
    },
    [params]
  );

  return (
    <div className="information">
      <Form ref={formRef} layout="inline" onValuesChange={debounceSearch}>
        <Form.Item label="搜索项" name="stage">
          <Input placeholder="请输入" maxLength={10} showCount allowClear />
        </Form.Item>
        <Form.Item>
          <Button onClick={handleReset}>重置</Button>
        </Form.Item>
      </Form>

      <Table
        loading={loading}
        className="page-table"
        dataSource={list}
        columns={COLUMNS}
        rowKey="id"
        pagination={{
          showQuickJumper: true,
          position: ["bottomCenter"],
          showSizeChanger: true,
          current: params.pageNum,
          pageSize: params.pageSize,
          total,
          onChange: paginationChange(),
        }}
      />
    </div>
  );
}
